<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>CCodeRefactoring: DeclProc.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(function() { init_search(); });
/* @license-end */
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">CCodeRefactoring
   &#160;<span id="projectnumber">First Alpha</span>
   </div>
   <div id="projectbrief">Create Simulation Executable From Existing Code</div>
  </td>
   <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_decl_proc_8h_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">DeclProc.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_decl_proc_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_type_proc_8h.html">TypeProc.h</a>&quot;</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160; </div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="keywordtype">void</span> <a class="code" href="_decl_proc_8h.html#a5f31e47fafc3b56fb55a8fdffa67a360">DeclDisPatcher</a>(bsoncxx::builder::basic::document&amp; CallingNode,<a class="code" href="struct_sub_level_properties.html">SubLevelProperties</a> &amp;SubLvlPrp,<a class="code" href="struct_binary_op_properties.html">BinaryOpProperties</a> &amp;BinOpProp,<span class="keyword">const</span> clang::NamedDecl *ND,<span class="keyword">const</span> SourceManager &amp;SourceManager);</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160; </div>
<div class="line"><a name="l00005"></a><span class="lineno"><a class="line" href="_decl_proc_8h.html#a93970f3b00cf4f70b0eadb2f100c5034">    5</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_decl_proc_8h.html#a93970f3b00cf4f70b0eadb2f100c5034">GetTypeInformationForDecl</a>(bsoncxx::builder::basic::document &amp;DeclNode,<span class="keyword">const</span> SourceManager &amp;SourceManager,<span class="keyword">const</span> DeclaratorDecl &amp;CLDeclNode,<a class="code" href="struct_binary_op_properties.html">BinaryOpProperties</a>   &amp;BinOpProp)</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;{</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;    TypeSourceInfo *TypeSrcPtr = CLDeclNode.getTypeSourceInfo();</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;    <span class="keywordflow">if</span>(TypeSrcPtr) <span class="comment">// Change of scope : discuss the type of the declaration</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;    {</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;        <span class="keywordtype">long</span> PAsInteger = <span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">long</span><span class="keyword">&gt;</span>(TypeSrcPtr); </div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;        std::string PAsString = std::to_string(PAsInteger);     </div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;        <span class="comment">//bsoncxx::builder::basic::document TypeNode;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;        <span class="comment">//GetTotalTypeLocation(TypeNode,TypePosition,TypeSrcPtr-&gt;getTypeLoc(),SourceManager);</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        bsoncxx::builder::basic::document TypeNode;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        <a class="code" href="_type_proc_8h.html#a6475dfc685f8a583f49bd17b563a37fa">analyzeTypes</a>(TypeNode,TypeSrcPtr-&gt;getType(),BinOpProp,SourceManager); </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        TypeNode.append(kvp(<span class="stringliteral">&quot;PtrOnTypeSrcInfo&quot;</span>,PAsString)); </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        DeclNode.append(kvp(<span class="stringliteral">&quot;Process&quot;</span>,BinOpProp.<a class="code" href="struct_binary_op_properties.html#ac975bdd8407c509fae99646f4a2dbf04">FuncName</a>)); </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        DeclNode.append(kvp(<span class="stringliteral">&quot;TypeName&quot;</span>,TypeSrcPtr-&gt;getType().getAsString()));   </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        DeclNode.append(kvp(<span class="stringliteral">&quot;TypestartLocationCode&quot;</span>,std::to_string(TypeSrcPtr-&gt;getTypeLoc().getSourceRange().getBegin().getRawEncoding())));</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        DeclNode.append(kvp(<span class="stringliteral">&quot;PtrOnTypeSrcInfoRef&quot;</span>,PAsString));</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        std::string name = TypeSrcPtr-&gt;getType().getAsString();</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        std::string getVarPtrs = <span class="stringliteral">&quot;SELECT types-&gt;&gt;&#39;PtrOnTypeSrcInfo&#39; FROM public.types WHERE types-&gt;&gt;&#39;name&#39;=&#39;&quot;</span>+name+<span class="stringliteral">&quot;&#39;;&quot;</span>;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        std::vector&lt;std::vector&lt;std::string&gt;&gt; resVarPtrs = <a class="code" href="postgres_interface_8hpp.html#a23641ff228bc4a84c18a7ae15c42ed77">genericQuery</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,getVarPtrs);</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        <span class="keywordflow">if</span>(!resVarPtrs.empty())</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        {</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;            std::vector&lt;std::string&gt; mdxVarPtrs  = <a class="code" href="recursive_hierarch_search_8hpp.html#a6c3aafef43e91acd0d2542ea2c5337ac">getNthColumn</a>(resVarPtrs,0);</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;            <span class="keywordtype">bool</span> ptrfound = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;            <span class="keywordflow">for</span>(std::vector&lt;std::string&gt;::iterator varIt = mdxVarPtrs.begin();varIt != mdxVarPtrs.end();varIt++)</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;            {</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;                std::string PtrStr = *varIt;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;                        </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;                <span class="keywordflow">if</span>(!PtrStr.empty())</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;                {</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;                    <span class="keywordflow">if</span>(PtrStr.compare(PAsString)==0)</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;                    {</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;                        ptrfound = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;                    }</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;                }                                           </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;            }</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;            <span class="keywordflow">if</span>(!ptrfound)                       </div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;            {           </div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;                <span class="keywordtype">bool</span> isInserted = <a class="code" href="postgres_interface_8hpp.html#a93a897241339ada0d6a3676765ae1d21">insertOneIntoCollection</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,<span class="stringliteral">&quot;Types&quot;</span>,<span class="stringliteral">&quot;Types&quot;</span>,TypeNode.extract()); </div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;            }</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        }</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        {</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;            <span class="keywordtype">bool</span> isInserted = <a class="code" href="postgres_interface_8hpp.html#a93a897241339ada0d6a3676765ae1d21">insertOneIntoCollection</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,<span class="stringliteral">&quot;Types&quot;</span>,<span class="stringliteral">&quot;Types&quot;</span>,TypeNode.extract()); </div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        }       </div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;     }<span class="comment">//End getTypeSourceInfo()</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;   return ;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;}</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160; </div>
<div class="line"><a name="l00058"></a><span class="lineno"><a class="line" href="_decl_proc_8h.html#a21232d055ec5d99ccaf9029ee5654848">   58</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_decl_proc_8h.html#a21232d055ec5d99ccaf9029ee5654848">GetTypeInformationForTypeDefNameDecl</a>(bsoncxx::builder::basic::document &amp;TypeDefNode,<span class="keyword">const</span> SourceManager &amp;SourceManager,<span class="keyword">const</span> clang::TypedefNameDecl *PtrTypeDefNameDecl,<a class="code" href="struct_binary_op_properties.html">BinaryOpProperties</a> &amp;BinOpProp)</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;{</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    TypeSourceInfo *TypeSrcPtr = PtrTypeDefNameDecl-&gt;getTypeSourceInfo();</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="keywordflow">if</span>(TypeSrcPtr) <span class="comment">// Change of scope : discuss the type of the declaration</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    {</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;     <a class="code" href="struct_total_location_info.html">TotalLocationInfo</a> Position; </div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;     <span class="comment">//GetTotalTypeLocation(TypeDefNode,Position,TypeSrcPtr-&gt;getTypeLoc(),SourceManager);   </span></div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;     <a class="code" href="_type_proc_8h.html#a6475dfc685f8a583f49bd17b563a37fa">analyzeTypes</a>(TypeDefNode,TypeSrcPtr-&gt;getType(),BinOpProp,SourceManager);       </div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;     }<span class="comment">//End getTypeSourceInfo()</span></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;  <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;}</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="keywordtype">void</span> <a class="code" href="_decl_proc_8h.html#a45cceb4fcef384f85e1c10274c240dc1">StructDeclProc</a>(bsoncxx::builder::basic::document&amp; StrcTypeNode,<a class="code" href="struct_sub_level_properties.html">SubLevelProperties</a> &amp;SubLvlPrp,<span class="keyword">const</span> clang::RecordDecl *RecD,<span class="keyword">const</span> SourceManager &amp;SourceManager,<a class="code" href="struct_binary_op_properties.html">BinaryOpProperties</a>   &amp;BinOpProp);</div>
<div class="line"><a name="l00070"></a><span class="lineno"><a class="line" href="_decl_proc_8h.html#a04d41e256eeb951cffd2a19125abf654">   70</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_decl_proc_8h.html#a04d41e256eeb951cffd2a19125abf654">storeVarsToDB</a>(bsoncxx::builder::basic::document &amp;VarDeclNode,<span class="keyword">const</span> VarDecl* VD,std::string PAsString)</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;{</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    std::string nameCurrent = VD-&gt;getNameAsString();                    </div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    std::string getVarPtrs = <span class="stringliteral">&quot;SELECT DISTINCT decls-&gt;&gt;&#39;PtrOnNode&#39; FROM public.declarations WHERE decls @&gt; &#39;{\&quot;name\&quot;:\&quot;&quot;</span>+nameCurrent+<span class="stringliteral">&quot;\&quot;}&#39;;&quot;</span>;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    std::vector&lt;std::vector&lt;std::string&gt;&gt; resVarPtrs = <a class="code" href="postgres_interface_8hpp.html#a23641ff228bc4a84c18a7ae15c42ed77">genericQuery</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,getVarPtrs);</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <span class="keywordflow">if</span>(!resVarPtrs.empty())</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    {</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        std::vector&lt;std::string&gt; mdxVarPtrs  = <a class="code" href="recursive_hierarch_search_8hpp.html#a6c3aafef43e91acd0d2542ea2c5337ac">getNthColumn</a>(resVarPtrs,0);</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        <span class="keywordtype">bool</span> ptrfound = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        <span class="keywordflow">for</span>(std::vector&lt;std::string&gt;::iterator varIt = mdxVarPtrs.begin();varIt != mdxVarPtrs.end();varIt++)</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        {</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;            std::string PtrStr = *varIt;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;                        </div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;                <span class="keywordflow">if</span>(!PtrStr.empty())</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;                {</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;                    <span class="keywordflow">if</span>(PtrStr.compare(PAsString)==0)</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;                    {</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;                        ptrfound = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;                    }</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;                }                                           </div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        }</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160; </div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        <span class="keywordflow">if</span>(!ptrfound)                       </div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        {           </div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;                <span class="keywordtype">bool</span> isInserted = <a class="code" href="postgres_interface_8hpp.html#a93a897241339ada0d6a3676765ae1d21">insertOneIntoCollection</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,<span class="stringliteral">&quot;Declarations&quot;</span>,<span class="stringliteral">&quot;Decls&quot;</span>,VarDeclNode.extract());  </div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        }</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    }</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <span class="keywordflow">else</span></div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    {</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        <span class="keywordtype">bool</span> isInserted = <a class="code" href="postgres_interface_8hpp.html#a93a897241339ada0d6a3676765ae1d21">insertOneIntoCollection</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,<span class="stringliteral">&quot;Declarations&quot;</span>,<span class="stringliteral">&quot;Decls&quot;</span>,VarDeclNode.extract());  </div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    }   </div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;}</div>
<div class="line"><a name="l00102"></a><span class="lineno"><a class="line" href="_decl_proc_8h.html#a9822762d5d3da96429cc8eb537152f0e">  102</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_decl_proc_8h.html#a9822762d5d3da96429cc8eb537152f0e">addTypeInfoToVar</a>(bsoncxx::builder::basic::document &amp;VarDeclNode,<a class="code" href="struct_sub_level_properties.html">SubLevelProperties</a> &amp;SubLvlPrp,<a class="code" href="struct_binary_op_properties.html">BinaryOpProperties</a> &amp;BinOpProp,<span class="keyword">const</span> VarDecl* VD,<span class="keyword">const</span> SourceManager &amp;SourceManager)</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;{</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    <span class="keyword">const</span> clang::Type *TypePtr  = VD-&gt;getType().getTypePtr();</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <span class="keywordtype">long</span> PAsInteger = <span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">long</span><span class="keyword">&gt;</span>(VD); </div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    std::string PAsString = std::to_string(PAsInteger);     </div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    <span class="keywordflow">if</span>(TypePtr-&gt;isPointerType())            </div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    {                           </div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        VarDeclNode.append(kvp(<span class="stringliteral">&quot;isPointer&quot;</span>,<span class="stringliteral">&quot;true&quot;</span>));    </div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        <span class="keyword">const</span> QualType QTPtr = TypePtr-&gt;getPointeeType();   </div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;        <span class="keyword">const</span> clang::Type *PtrTypePtr  = QTPtr.getTypePtr();            </div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        <span class="keyword">const</span> TypedefType *TPDef =  PtrTypePtr-&gt;getAs&lt;TypedefType&gt;();</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;        <span class="keywordflow">if</span>(TPDef)</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;        {</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;            VarDeclNode.append(kvp(<span class="stringliteral">&quot;isPointerOnTypeDef&quot;</span>,<span class="stringliteral">&quot;true&quot;</span>));   </div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;            bsoncxx::builder::basic::document TypeDefNode;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;            TypedefNameDecl *TDN =  TPDef-&gt;getDecl();</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;            std::string TDNName = TDN-&gt;getNameAsString();</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;            VarDeclNode.append(kvp(<span class="stringliteral">&quot;typedefname&quot;</span>,TDNName)); </div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;            clang::RecordDecl *RDTPDef = TPDef-&gt;getAsRecordDecl();</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;            <span class="keywordflow">if</span>(RDTPDef)</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;            {</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;                VarDeclNode.append(kvp(<span class="stringliteral">&quot;isStruct&quot;</span>,<span class="stringliteral">&quot;true&quot;</span>)); </div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;                bsoncxx::builder::basic::document StrcTypeNode;</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;                <span class="keywordtype">long</span> PAsIntegerStrct = <span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">long</span><span class="keyword">&gt;</span>(RDTPDef); </div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;                std::string PAsStringStrct = std::to_string(PAsIntegerStrct);       </div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;                StrcTypeNode.append(kvp(<span class="stringliteral">&quot;PtrOnStrucNode&quot;</span>,PAsStringStrct));</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;                StrcTypeNode.append(kvp(<span class="stringliteral">&quot;typedefname&quot;</span>,TDNName));</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;                StrcTypeNode.append(kvp(<span class="stringliteral">&quot;PtrOnParentVarDeclNode&quot;</span>,PAsString));   </div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;                    </div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160; </div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;                std::string nameCurrent = TDNName;                  </div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;                std::string getVarPtrs = <span class="stringliteral">&quot;SELECT DISTINCT structs-&gt;&gt;&#39;PtrOnStrucNode&#39; FROM public.structures WHERE structs @&gt; &#39;{\&quot;typedefname\&quot;:\&quot;&quot;</span>+nameCurrent+<span class="stringliteral">&quot;\&quot;}&#39;;&quot;</span>;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;                std::vector&lt;std::vector&lt;std::string&gt;&gt; resVarPtrs = <a class="code" href="postgres_interface_8hpp.html#a23641ff228bc4a84c18a7ae15c42ed77">genericQuery</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,getVarPtrs);</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;                <span class="keywordflow">if</span>(!resVarPtrs.empty())</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;                {</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;                    std::vector&lt;std::string&gt; mdxVarPtrs  = <a class="code" href="recursive_hierarch_search_8hpp.html#a6c3aafef43e91acd0d2542ea2c5337ac">getNthColumn</a>(resVarPtrs,0);</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;                    <span class="keywordtype">bool</span> ptrfound = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;                    <span class="keywordflow">for</span>(std::vector&lt;std::string&gt;::iterator varIt = mdxVarPtrs.begin();varIt != mdxVarPtrs.end();varIt++)</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;                    {</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;                        std::string PtrStr = *varIt;</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;                        </div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;                        <span class="keywordflow">if</span>(!PtrStr.empty())</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;                        {</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;                            <span class="keywordflow">if</span>(PtrStr.compare(PAsStringStrct)==0)</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;                            {</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;                                ptrfound = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;                            }</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;                        }                                           </div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;                    }</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160; </div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;                    <span class="keywordflow">if</span>(!ptrfound)                       </div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;                    {</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;                        <a class="code" href="_decl_proc_8h.html#a45cceb4fcef384f85e1c10274c240dc1">StructDeclProc</a>(StrcTypeNode,SubLvlPrp,RDTPDef,SourceManager,BinOpProp); </div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;                        <span class="keywordtype">bool</span> isInserted = <a class="code" href="postgres_interface_8hpp.html#a93a897241339ada0d6a3676765ae1d21">insertOneIntoCollection</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,<span class="stringliteral">&quot;structures&quot;</span>,<span class="stringliteral">&quot;structs&quot;</span>,StrcTypeNode.extract());  </div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;                    }</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;                }</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;                <span class="keywordflow">else</span></div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;                {</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;                    <a class="code" href="_decl_proc_8h.html#a45cceb4fcef384f85e1c10274c240dc1">StructDeclProc</a>(StrcTypeNode,SubLvlPrp,RDTPDef,SourceManager,BinOpProp); </div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;                    <span class="keywordtype">bool</span> isInserted = <a class="code" href="postgres_interface_8hpp.html#a93a897241339ada0d6a3676765ae1d21">insertOneIntoCollection</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,<span class="stringliteral">&quot;structures&quot;</span>,<span class="stringliteral">&quot;structs&quot;</span>,StrcTypeNode.extract());  </div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;                }           </div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;            }               </div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;            <span class="keywordflow">else</span></div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;            {</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;                    VarDeclNode.append(kvp(<span class="stringliteral">&quot;isStruct&quot;</span>,<span class="stringliteral">&quot;false&quot;</span>));    </div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;            }</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;        }</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        {</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;            VarDeclNode.append(kvp(<span class="stringliteral">&quot;isPointerOnTypeDef&quot;</span>,<span class="stringliteral">&quot;false&quot;</span>));  </div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        }</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        <span class="keywordtype">bool</span> isConstPtr = QTPtr.isConstQualified();</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        <span class="keywordflow">if</span>(isConstPtr)</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        {</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;            VarDeclNode.append(kvp(<span class="stringliteral">&quot;isConstPtr&quot;</span>,<span class="stringliteral">&quot;true&quot;</span>));   </div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        }</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        {</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;            VarDeclNode.append(kvp(<span class="stringliteral">&quot;isConstPtr&quot;</span>,<span class="stringliteral">&quot;false&quot;</span>));  </div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        }                                               </div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    }       </div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    <span class="keywordflow">else</span></div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    {</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        VarDeclNode.append(kvp(<span class="stringliteral">&quot;isPointer&quot;</span>,<span class="stringliteral">&quot;false&quot;</span>));   </div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    }  </div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;}</div>
<div class="line"><a name="l00188"></a><span class="lineno"><a class="line" href="_decl_proc_8h.html#a6f02fe5969c9a38f99703a3a29b776d6">  188</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_decl_proc_8h.html#a6f02fe5969c9a38f99703a3a29b776d6">VarDeclProc</a>(bsoncxx::builder::basic::document &amp;VarDeclNode,<a class="code" href="struct_sub_level_properties.html">SubLevelProperties</a> &amp;SubLvlPrp,<a class="code" href="struct_binary_op_properties.html">BinaryOpProperties</a> &amp;BinOpProp,<span class="keyword">const</span> VarDecl* VD,<span class="keyword">const</span> SourceManager &amp;SourceManager)</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;{</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;    </div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    <span class="keywordtype">long</span> PAsInteger = <span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">long</span><span class="keyword">&gt;</span>(VD); </div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    std::string PAsString = std::to_string(PAsInteger);     </div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;    VarDeclNode.append(kvp(<span class="stringliteral">&quot;Process&quot;</span>,BinOpProp.<a class="code" href="struct_binary_op_properties.html#ac975bdd8407c509fae99646f4a2dbf04">FuncName</a>));</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    VarDeclNode.append(kvp(<span class="stringliteral">&quot;DeclType&quot;</span>,<span class="stringliteral">&quot;VarDecl&quot;</span>));</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    VarDeclNode.append(kvp(<span class="stringliteral">&quot;PtrOnNode&quot;</span>,PAsString)); </div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;    VarDeclNode.append(kvp(<span class="stringliteral">&quot;PtrOnDecl&quot;</span>,PAsString));</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    std::string extStr = VD-&gt;hasExternalStorage() ?   <span class="stringliteral">&quot;yes&quot;</span>:<span class="stringliteral">&quot;no&quot;</span>;</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    std::string globStr = VD-&gt;hasGlobalStorage() ?   <span class="stringliteral">&quot;yes&quot;</span>:<span class="stringliteral">&quot;no&quot;</span>;</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;    VarDeclNode.append(kvp(<span class="stringliteral">&quot;extern&quot;</span>,extStr));</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    VarDeclNode.append(kvp(<span class="stringliteral">&quot;global&quot;</span>,globStr));  </div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;    VarDeclNode.append(kvp(<span class="stringliteral">&quot;name&quot;</span>,VD-&gt;getName().str()));</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160; </div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    <span class="keyword">const</span> clang::DeclContext* dc = VD-&gt;getDeclContext();</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;    <span class="keyword">const</span> Decl* dcl_parent = dyn_cast&lt;Decl&gt;(dc);                    </div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;    <span class="keywordflow">if</span>(dcl_parent)</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    {</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        <span class="keyword">const</span> NamedDecl* ND = dyn_cast&lt;NamedDecl&gt;(dcl_parent);</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;        <span class="keywordflow">if</span>(ND)</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;        {</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;            ND-&gt;getNameAsString();</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;            VarDeclNode.append(kvp(<span class="stringliteral">&quot;ParentName&quot;</span>,ND-&gt;getNameAsString()));</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;        }</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">char</span> *KndName =  dc-&gt;getDeclKindName();   </div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;        std::string KndNameStr = KndName;</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;        VarDeclNode.append(kvp(<span class="stringliteral">&quot;ParentKindName&quot;</span>,KndNameStr));                   </div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;    }</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    <span class="keyword">enum</span> clang::StorageClass SC = VD-&gt;getStorageClass(); </div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;    <span class="keywordflow">switch</span>(SC)</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;    {</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        <span class="keywordflow">case</span> SC_None : VarDeclNode.append(kvp(<span class="stringliteral">&quot;StorageClass&quot;</span>,<span class="stringliteral">&quot;SC_None&quot;</span>)); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        <span class="keywordflow">case</span> SC_Extern : VarDeclNode.append(kvp(<span class="stringliteral">&quot;StorageClass&quot;</span>,<span class="stringliteral">&quot;SC_Extern&quot;</span>)); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        <span class="keywordflow">case</span> SC_Static : VarDeclNode.append(kvp(<span class="stringliteral">&quot;StorageClass&quot;</span>,<span class="stringliteral">&quot;SC_Static&quot;</span>)); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;        <span class="keywordflow">case</span> SC_PrivateExtern : VarDeclNode.append(kvp(<span class="stringliteral">&quot;StorageClass&quot;</span>,<span class="stringliteral">&quot;SC_PrivateExtern&quot;</span>)); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;        <span class="keywordflow">case</span> SC_Auto : VarDeclNode.append(kvp(<span class="stringliteral">&quot;StorageClass&quot;</span>,<span class="stringliteral">&quot;SC_Auto&quot;</span>)); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;        <span class="keywordflow">case</span> SC_Register : VarDeclNode.append(kvp(<span class="stringliteral">&quot;StorageClass&quot;</span>,<span class="stringliteral">&quot;SC_Register&quot;</span>)); <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;    }</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;                        </div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;    <span class="comment">// MainNode.append(kvp(&quot;PtrOnDecl&quot;,PAsString));</span></div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;                        </div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    <span class="keywordtype">bool</span> isConst = VD-&gt;getType().isConstQualified();</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;    <span class="keywordflow">if</span>(isConst)</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    {</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;        VarDeclNode.append(kvp(<span class="stringliteral">&quot;isConst&quot;</span>,<span class="stringliteral">&quot;true&quot;</span>));</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;    }   </div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;    <span class="keywordflow">else</span></div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;    {</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;        VarDeclNode.append(kvp(<span class="stringliteral">&quot;isConst&quot;</span>,<span class="stringliteral">&quot;false&quot;</span>));</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;    }</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;    <span class="keywordtype">bool</span> isVolatile = VD-&gt;getType().isVolatileQualified();</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;    <span class="keywordflow">if</span>(isVolatile)</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;    {</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        VarDeclNode.append(kvp(<span class="stringliteral">&quot;isVolatile&quot;</span>,<span class="stringliteral">&quot;true&quot;</span>));</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;    }</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;    <span class="keywordflow">else</span></div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;    {</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        VarDeclNode.append(kvp(<span class="stringliteral">&quot;isVolatile&quot;</span>,<span class="stringliteral">&quot;false&quot;</span>));</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;    }</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160; </div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160; </div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;        </div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;    <span class="keyword">const</span> VarDecl *DefVar =     VD-&gt;getDefinition();</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;    <span class="keywordflow">if</span>(DefVar)</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;    {</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;        VarDeclNode.append(kvp(<span class="stringliteral">&quot;hasDefinition&quot;</span>,<span class="stringliteral">&quot;yes&quot;</span>));</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;    }</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;    <span class="keywordflow">else</span></div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;    { </div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;        VarDeclNode.append(kvp(<span class="stringliteral">&quot;hasDefinition&quot;</span>,<span class="stringliteral">&quot;no&quot;</span>));</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;    }</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160; </div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;    <a class="code" href="_decl_proc_8h.html#a9822762d5d3da96429cc8eb537152f0e">addTypeInfoToVar</a>(VarDeclNode,SubLvlPrp,BinOpProp,VD,SourceManager);</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;    <a class="code" href="_decl_proc_8h.html#a93970f3b00cf4f70b0eadb2f100c5034">GetTypeInformationForDecl</a>(VarDeclNode,SourceManager,*VD,BinOpProp);                 </div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;    <a class="code" href="_decl_proc_8h.html#a04d41e256eeb951cffd2a19125abf654">storeVarsToDB</a>(VarDeclNode,VD,PAsString);</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160; </div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;    <span class="keywordflow">return</span>; </div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;}   </div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;    </div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160; </div>
<div class="line"><a name="l00269"></a><span class="lineno"><a class="line" href="_decl_proc_8h.html#ab38ac3e115c112a92798d1bde32ed22d">  269</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_decl_proc_8h.html#ab38ac3e115c112a92798d1bde32ed22d">FuncDeclProc</a>(bsoncxx::builder::basic::document &amp;FuncDeclNode,<a class="code" href="struct_sub_level_properties.html">SubLevelProperties</a> &amp;SubLvlPrp,<span class="keyword">const</span> FunctionDecl *FD,<span class="keyword">const</span> SourceManager &amp;SourceManager,<a class="code" href="struct_binary_op_properties.html">BinaryOpProperties</a>    &amp;BinOpProp)</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;{</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;    <span class="keywordflow">if</span>(FD)</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;    {   </div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;        bsoncxx::builder::basic::document TypeNode;</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;        <a class="code" href="struct_total_location_info.html">TotalLocationInfo</a> Position;</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;        <span class="comment">//</span></div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;        <span class="comment">//GetTotalDeclLocation(FuncDeclNode,Position,*FD,SourceManager);</span></div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160; </div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;        <span class="keywordtype">long</span> PAsInteger = <span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">long</span><span class="keyword">&gt;</span>(FD); </div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;        std::string PAsString = std::to_string(PAsInteger);         </div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;        FuncDeclNode.append(kvp(<span class="stringliteral">&quot;PtrOnNode&quot;</span>,PAsString));        </div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;        FuncDeclNode.append(kvp(<span class="stringliteral">&quot;Process&quot;</span>,BinOpProp.<a class="code" href="struct_binary_op_properties.html#ac975bdd8407c509fae99646f4a2dbf04">FuncName</a>)); </div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;        FuncDeclNode.append(kvp(<span class="stringliteral">&quot;functionname&quot;</span>,FD-&gt;getNameAsString()));</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;        FuncDeclNode.append(kvp(<span class="stringliteral">&quot;isDefinition&quot;</span>,FD-&gt;isThisDeclarationADefinition() ? <span class="stringliteral">&quot;yes&quot;</span>:<span class="stringliteral">&quot;no&quot;</span>));</div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;        <span class="keyword">const</span> clang::FunctionDecl *FDefinition = FD-&gt;getDefinition();</div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;        <span class="keywordflow">if</span>(FDefinition) FuncDeclNode.append(kvp(<span class="stringliteral">&quot;hasDefinThisTU&quot;</span>,<span class="stringliteral">&quot;yes&quot;</span>));</div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;        <span class="keywordflow">else</span> FuncDeclNode.append(kvp(<span class="stringliteral">&quot;hasDefinThisTU&quot;</span>,<span class="stringliteral">&quot;no&quot;</span>));</div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;        FuncDeclNode.append(kvp(<span class="stringliteral">&quot;isGlobal&quot;</span>,FD-&gt;isGlobal() ? <span class="stringliteral">&quot;yes&quot;</span>:<span class="stringliteral">&quot;no&quot;</span>));</div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;        FuncDeclNode.append(kvp(<span class="stringliteral">&quot;hasReturnValue&quot;</span>,FD-&gt;isNoReturn() ? <span class="stringliteral">&quot;no&quot;</span>:<span class="stringliteral">&quot;yes&quot;</span>));               </div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;        <a class="code" href="struct_sub_level_properties.html">SubLevelProperties</a> SubLvlPrp;       </div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;        <a class="code" href="_decl_proc_8h.html#a93970f3b00cf4f70b0eadb2f100c5034">GetTypeInformationForDecl</a>(FuncDeclNode,SourceManager,*FD,BinOpProp);                </div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;        <span class="keywordflow">if</span>(!(FD-&gt;isNoReturn())) </div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;        {</div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;            <a class="code" href="_type_proc_8h.html#a6475dfc685f8a583f49bd17b563a37fa">analyzeTypes</a>(FuncDeclNode,FD-&gt;getReturnType(),BinOpProp,SourceManager);</div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;        }</div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160; </div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;        bsoncxx::document::view docvw = FuncDeclNode.view();</div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;        <span class="keywordflow">if</span>(!docvw.empty())</div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;        {</div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;            std::string index   = <a class="code" href="_process_location_8h.html#ad4b771fd12a876bc2b0e55d207cc11ae">ReadUtf8Element</a>(docvw,<span class="stringliteral">&quot;id&quot;</span>);</div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;            std::string stmtStr = <a class="code" href="_process_location_8h.html#ad4b771fd12a876bc2b0e55d207cc11ae">ReadUtf8Element</a>(docvw,<span class="stringliteral">&quot;Stmt&quot;</span>);</div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;            std::pair&lt;std::string,std::string&gt; refStmt;</div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;            refStmt.first = index;</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;            refStmt.second = stmtStr;</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;        </div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;            <span class="keywordtype">unsigned</span> NumParam       = FD-&gt;getNumParams();</div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;            </div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;            <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> iter=0;iter!=NumParam;iter++)</div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;            {</div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;                std::string par=<span class="stringliteral">&quot;ParamVarDecl_&quot;</span>;</div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;                par = par+std::to_string(iter);</div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;                <span class="keyword">const</span> ParmVarDecl *ParmVar = FD-&gt;getParamDecl(iter);    </div>
<div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;                <a class="code" href="_decl_proc_8h.html#a5f31e47fafc3b56fb55a8fdffa67a360">DeclDisPatcher</a>(FuncDeclNode,SubLvlPrp,BinOpProp,ParmVar,SourceManager);</div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;            }</div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160; </div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;        }   </div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;        std::string getFuncPtrs = <span class="stringliteral">&quot;SELECT DISTINCT FunctionDecls-&gt;&gt;&#39;PtrOnNode&#39; FROM public.FunctionDeclarations WHERE FunctionDecls @&gt; &#39;{\&quot;functionname\&quot;:\&quot;&quot;</span>+FD-&gt;getNameAsString()+<span class="stringliteral">&quot;\&quot;}&#39;;&quot;</span>;</div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;        std::vector&lt;std::vector&lt;std::string&gt;&gt; resFuncPtrs = <a class="code" href="postgres_interface_8hpp.html#a23641ff228bc4a84c18a7ae15c42ed77">genericQuery</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,getFuncPtrs);</div>
<div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;        <span class="keywordflow">if</span>(!resFuncPtrs.empty())</div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;        {</div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;            std::vector&lt;std::string&gt; FuncPtrs  = <a class="code" href="recursive_hierarch_search_8hpp.html#a6c3aafef43e91acd0d2542ea2c5337ac">getNthColumn</a>(resFuncPtrs,0);</div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;            <span class="keywordtype">bool</span> ptrfound = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;            <span class="keywordflow">for</span>(std::vector&lt;std::string&gt;::iterator varIt = FuncPtrs.begin();varIt != FuncPtrs.end();varIt++)</div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;            {</div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;                std::string PtrStr = *varIt;</div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;                        </div>
<div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;                <span class="keywordflow">if</span>(!PtrStr.empty())</div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;                {</div>
<div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;                    <span class="keywordflow">if</span>(PtrStr.compare(PAsString)==0)</div>
<div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;                    {</div>
<div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;                        ptrfound = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;                    }</div>
<div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;                }                                           </div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;            }</div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;            <span class="keywordflow">if</span>(!ptrfound)                       </div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;            {                       </div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;                <span class="keywordtype">bool</span> isInserted = <a class="code" href="postgres_interface_8hpp.html#a93a897241339ada0d6a3676765ae1d21">insertOneIntoCollection</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,<span class="stringliteral">&quot;FunctionDeclarations&quot;</span>,<span class="stringliteral">&quot;FunctionDecls&quot;</span>,FuncDeclNode.extract());    </div>
<div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;            }</div>
<div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;        }</div>
<div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;        {                   </div>
<div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;            <span class="keywordtype">bool</span> isInserted = <a class="code" href="postgres_interface_8hpp.html#a93a897241339ada0d6a3676765ae1d21">insertOneIntoCollection</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,<span class="stringliteral">&quot;FunctionDeclarations&quot;</span>,<span class="stringliteral">&quot;FunctionDecls&quot;</span>,FuncDeclNode.extract());  </div>
<div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;        }               </div>
<div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;    }</div>
<div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160; </div>
<div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;    <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;}</div>
<div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160; </div>
<div class="line"><a name="l00348"></a><span class="lineno"><a class="line" href="_decl_proc_8h.html#a76cf24d93902e040ec03c2d5d5080d9d">  348</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_decl_proc_8h.html#a76cf24d93902e040ec03c2d5d5080d9d">FieldDeclProc</a>(bsoncxx::builder::basic::document &amp;FieldDeclNode,<a class="code" href="struct_sub_level_properties.html">SubLevelProperties</a> &amp;SubLvlPrp,<span class="keyword">const</span> FieldDecl *FD,<span class="keyword">const</span> SourceManager &amp;SourceManager,<a class="code" href="struct_binary_op_properties.html">BinaryOpProperties</a> &amp;BinOpProp)</div>
<div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;{</div>
<div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;  </div>
<div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;    <span class="keywordflow">if</span>(FD)</div>
<div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;    {       </div>
<div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;        <a class="code" href="struct_total_location_info.html">TotalLocationInfo</a> Position;</div>
<div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;        <span class="comment">//GetTotalDeclLocation(FieldDeclNode,Position,*FD,SourceManager);</span></div>
<div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160; </div>
<div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;        FieldDeclNode.append(kvp(<span class="stringliteral">&quot;name&quot;</span>,FD-&gt;getNameAsString()));</div>
<div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;        <a class="code" href="_decl_proc_8h.html#a93970f3b00cf4f70b0eadb2f100c5034">GetTypeInformationForDecl</a>(FieldDeclNode,SourceManager,*FD,BinOpProp);                   </div>
<div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;    }</div>
<div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;    <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;}</div>
<div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160; </div>
<div class="line"><a name="l00362"></a><span class="lineno"><a class="line" href="_decl_proc_8h.html#a45cceb4fcef384f85e1c10274c240dc1">  362</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_decl_proc_8h.html#a45cceb4fcef384f85e1c10274c240dc1">StructDeclProc</a>(bsoncxx::builder::basic::document&amp; StrcTypeNode,<a class="code" href="struct_sub_level_properties.html">SubLevelProperties</a> &amp;SubLvlPrp,<span class="keyword">const</span> clang::RecordDecl *RecD,<span class="keyword">const</span> SourceManager &amp;SourceManager,<a class="code" href="struct_binary_op_properties.html">BinaryOpProperties</a>   &amp;BinOpProp)</div>
<div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;{</div>
<div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;  </div>
<div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;    <span class="keywordflow">if</span>(RecD)</div>
<div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;        {</div>
<div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160; </div>
<div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;        <a class="code" href="struct_total_location_info.html">TotalLocationInfo</a> Position;</div>
<div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;        <span class="comment">//GetTotalDeclLocation(StrcTypeNode,Position,*RecD,SourceManager);</span></div>
<div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;        </div>
<div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;        <a class="code" href="_type_proc_8h.html#ae5080d20d1c8746138bb4d32306f33bb">AnalyseType</a>(StrcTypeNode,RecD-&gt;getTypeForDecl(),BinOpProp,SourceManager);</div>
<div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;        <a class="code" href="struct_sub_level_properties.html">SubLevelProperties</a> SubLvlPrp;</div>
<div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;        <span class="keywordtype">unsigned</span> ctr=0;</div>
<div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;        std::string attr=<span class="stringliteral">&quot;field decl no:&quot;</span>;</div>
<div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;        bsoncxx::builder::basic::array array_builder_nm = bsoncxx::builder::basic::array{};</div>
<div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;        <span class="keywordflow">for</span> (<span class="keyword">const</span> FieldDecl *Field : RecD-&gt;fields())</div>
<div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;        {</div>
<div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;            bsoncxx::builder::basic::document FieldTypeNode;</div>
<div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;            attr = attr + std::to_string(ctr);</div>
<div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;            <a class="code" href="_decl_proc_8h.html#a76cf24d93902e040ec03c2d5d5080d9d">FieldDeclProc</a>(FieldTypeNode,SubLvlPrp,Field,SourceManager,BinOpProp);</div>
<div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;            array_builder_nm.append(FieldTypeNode);</div>
<div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;            ctr++;</div>
<div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;        }</div>
<div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;        StrcTypeNode.append(kvp(<span class="stringliteral">&quot;fieldDecls&quot;</span>,array_builder_nm));</div>
<div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;        }</div>
<div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;    <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;}</div>
<div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160; </div>
<div class="line"><a name="l00389"></a><span class="lineno"><a class="line" href="_decl_proc_8h.html#a745102550bf2062df80f1291adc0378d">  389</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_decl_proc_8h.html#a745102550bf2062df80f1291adc0378d">TypeDefNameDeclProc</a>(bsoncxx::builder::basic::document &amp;TypeDefNode,<span class="keyword">const</span> TypedefNameDecl *PtrTypeDefNameDecl,<span class="keyword">const</span> SourceManager &amp;SourceManager,<a class="code" href="struct_binary_op_properties.html">BinaryOpProperties</a> &amp;BinOpProp)</div>
<div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;{</div>
<div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;  <span class="keywordflow">if</span>(PtrTypeDefNameDecl)</div>
<div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;  {             </div>
<div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;    IdentifierInfo *PtrTypeDefIdentifier =  PtrTypeDefNameDecl-&gt;getIdentifier();</div>
<div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;    <span class="keywordflow">if</span>(PtrTypeDefIdentifier) TypeDefNode.append(kvp(<span class="stringliteral">&quot;PtrName&quot;</span>,PtrTypeDefIdentifier-&gt;getName().str())); </div>
<div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160; </div>
<div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;    <a class="code" href="struct_total_location_info.html">TotalLocationInfo</a> Position;   </div>
<div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;    bsoncxx::builder::basic::document MainNode;</div>
<div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;    <span class="comment">//GetTotalDeclLocation(TypeDefNode,Position,*PtrTypeDefNameDecl,SourceManager);</span></div>
<div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;                </div>
<div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;    <a class="code" href="_decl_proc_8h.html#a21232d055ec5d99ccaf9029ee5654848">GetTypeInformationForTypeDefNameDecl</a>(TypeDefNode,SourceManager,PtrTypeDefNameDecl,BinOpProp);</div>
<div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;    </div>
<div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;  }</div>
<div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160; </div>
<div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;    <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;}</div>
<div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160; </div>
<div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160; </div>
<div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160; </div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="apostgres_interface_8hpp_html_a23641ff228bc4a84c18a7ae15c42ed77"><div class="ttname"><a href="postgres_interface_8hpp.html#a23641ff228bc4a84c18a7ae15c42ed77">genericQuery</a></div><div class="ttdeci">std::vector&lt; std::vector&lt; std::string &gt; &gt; genericQuery(std::string dbName, std::string query)</div><div class="ttdef"><b>Definition:</b> postgresInterface.hpp:759</div></div>
<div class="ttc" id="a_decl_proc_8h_html_a45cceb4fcef384f85e1c10274c240dc1"><div class="ttname"><a href="_decl_proc_8h.html#a45cceb4fcef384f85e1c10274c240dc1">StructDeclProc</a></div><div class="ttdeci">void StructDeclProc(bsoncxx::builder::basic::document &amp;StrcTypeNode, SubLevelProperties &amp;SubLvlPrp, const clang::RecordDecl *RecD, const SourceManager &amp;SourceManager, BinaryOpProperties &amp;BinOpProp)</div><div class="ttdef"><b>Definition:</b> DeclProc.h:362</div></div>
<div class="ttc" id="astruct_sub_level_properties_html"><div class="ttname"><a href="struct_sub_level_properties.html">SubLevelProperties</a></div><div class="ttdef"><b>Definition:</b> TypesForAnalysis.h:544</div></div>
<div class="ttc" id="a_decl_proc_8h_html_a745102550bf2062df80f1291adc0378d"><div class="ttname"><a href="_decl_proc_8h.html#a745102550bf2062df80f1291adc0378d">TypeDefNameDeclProc</a></div><div class="ttdeci">void TypeDefNameDeclProc(bsoncxx::builder::basic::document &amp;TypeDefNode, const TypedefNameDecl *PtrTypeDefNameDecl, const SourceManager &amp;SourceManager, BinaryOpProperties &amp;BinOpProp)</div><div class="ttdef"><b>Definition:</b> DeclProc.h:389</div></div>
<div class="ttc" id="a_type_proc_8h_html_ae5080d20d1c8746138bb4d32306f33bb"><div class="ttname"><a href="_type_proc_8h.html#ae5080d20d1c8746138bb4d32306f33bb">AnalyseType</a></div><div class="ttdeci">void AnalyseType(bsoncxx::builder::basic::document &amp;TypeNode, const clang::Type *PtrType, BinaryOpProperties &amp;BinOpProp, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> TypeProc.h:112</div></div>
<div class="ttc" id="a_decl_proc_8h_html_a76cf24d93902e040ec03c2d5d5080d9d"><div class="ttname"><a href="_decl_proc_8h.html#a76cf24d93902e040ec03c2d5d5080d9d">FieldDeclProc</a></div><div class="ttdeci">void FieldDeclProc(bsoncxx::builder::basic::document &amp;FieldDeclNode, SubLevelProperties &amp;SubLvlPrp, const FieldDecl *FD, const SourceManager &amp;SourceManager, BinaryOpProperties &amp;BinOpProp)</div><div class="ttdef"><b>Definition:</b> DeclProc.h:348</div></div>
<div class="ttc" id="astruct_binary_op_properties_html_ac975bdd8407c509fae99646f4a2dbf04"><div class="ttname"><a href="struct_binary_op_properties.html#ac975bdd8407c509fae99646f4a2dbf04">BinaryOpProperties::FuncName</a></div><div class="ttdeci">std::string FuncName</div><div class="ttdef"><b>Definition:</b> TypesForAnalysis.h:593</div></div>
<div class="ttc" id="a_decl_proc_8h_html_a21232d055ec5d99ccaf9029ee5654848"><div class="ttname"><a href="_decl_proc_8h.html#a21232d055ec5d99ccaf9029ee5654848">GetTypeInformationForTypeDefNameDecl</a></div><div class="ttdeci">void GetTypeInformationForTypeDefNameDecl(bsoncxx::builder::basic::document &amp;TypeDefNode, const SourceManager &amp;SourceManager, const clang::TypedefNameDecl *PtrTypeDefNameDecl, BinaryOpProperties &amp;BinOpProp)</div><div class="ttdef"><b>Definition:</b> DeclProc.h:58</div></div>
<div class="ttc" id="a_decl_proc_8h_html_a6f02fe5969c9a38f99703a3a29b776d6"><div class="ttname"><a href="_decl_proc_8h.html#a6f02fe5969c9a38f99703a3a29b776d6">VarDeclProc</a></div><div class="ttdeci">void VarDeclProc(bsoncxx::builder::basic::document &amp;VarDeclNode, SubLevelProperties &amp;SubLvlPrp, BinaryOpProperties &amp;BinOpProp, const VarDecl *VD, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclProc.h:188</div></div>
<div class="ttc" id="a_type_proc_8h_html"><div class="ttname"><a href="_type_proc_8h.html">TypeProc.h</a></div></div>
<div class="ttc" id="a_decl_proc_8h_html_ab38ac3e115c112a92798d1bde32ed22d"><div class="ttname"><a href="_decl_proc_8h.html#ab38ac3e115c112a92798d1bde32ed22d">FuncDeclProc</a></div><div class="ttdeci">void FuncDeclProc(bsoncxx::builder::basic::document &amp;FuncDeclNode, SubLevelProperties &amp;SubLvlPrp, const FunctionDecl *FD, const SourceManager &amp;SourceManager, BinaryOpProperties &amp;BinOpProp)</div><div class="ttdef"><b>Definition:</b> DeclProc.h:269</div></div>
<div class="ttc" id="apostgres_interface_8hpp_html_a93a897241339ada0d6a3676765ae1d21"><div class="ttname"><a href="postgres_interface_8hpp.html#a93a897241339ada0d6a3676765ae1d21">insertOneIntoCollection</a></div><div class="ttdeci">bool insertOneIntoCollection(std::string dbName, std::string table, std::string column, bsoncxx::document::value doc_val)</div><div class="ttdef"><b>Definition:</b> postgresInterface.hpp:66</div></div>
<div class="ttc" id="a_decl_proc_8h_html_a93970f3b00cf4f70b0eadb2f100c5034"><div class="ttname"><a href="_decl_proc_8h.html#a93970f3b00cf4f70b0eadb2f100c5034">GetTypeInformationForDecl</a></div><div class="ttdeci">void GetTypeInformationForDecl(bsoncxx::builder::basic::document &amp;DeclNode, const SourceManager &amp;SourceManager, const DeclaratorDecl &amp;CLDeclNode, BinaryOpProperties &amp;BinOpProp)</div><div class="ttdef"><b>Definition:</b> DeclProc.h:5</div></div>
<div class="ttc" id="a_decl_proc_8h_html_a9822762d5d3da96429cc8eb537152f0e"><div class="ttname"><a href="_decl_proc_8h.html#a9822762d5d3da96429cc8eb537152f0e">addTypeInfoToVar</a></div><div class="ttdeci">void addTypeInfoToVar(bsoncxx::builder::basic::document &amp;VarDeclNode, SubLevelProperties &amp;SubLvlPrp, BinaryOpProperties &amp;BinOpProp, const VarDecl *VD, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclProc.h:102</div></div>
<div class="ttc" id="a_decl_proc_8h_html_a04d41e256eeb951cffd2a19125abf654"><div class="ttname"><a href="_decl_proc_8h.html#a04d41e256eeb951cffd2a19125abf654">storeVarsToDB</a></div><div class="ttdeci">void storeVarsToDB(bsoncxx::builder::basic::document &amp;VarDeclNode, const VarDecl *VD, std::string PAsString)</div><div class="ttdef"><b>Definition:</b> DeclProc.h:70</div></div>
<div class="ttc" id="astruct_binary_op_properties_html"><div class="ttname"><a href="struct_binary_op_properties.html">BinaryOpProperties</a></div><div class="ttdef"><b>Definition:</b> TypesForAnalysis.h:561</div></div>
<div class="ttc" id="a_decl_proc_8h_html_a5f31e47fafc3b56fb55a8fdffa67a360"><div class="ttname"><a href="_decl_proc_8h.html#a5f31e47fafc3b56fb55a8fdffa67a360">DeclDisPatcher</a></div><div class="ttdeci">void DeclDisPatcher(bsoncxx::builder::basic::document &amp;CallingNode, SubLevelProperties &amp;SubLvlPrp, BinaryOpProperties &amp;BinOpProp, const clang::NamedDecl *ND, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:11</div></div>
<div class="ttc" id="a_process_location_8h_html_ad4b771fd12a876bc2b0e55d207cc11ae"><div class="ttname"><a href="_process_location_8h.html#ad4b771fd12a876bc2b0e55d207cc11ae">ReadUtf8Element</a></div><div class="ttdeci">std::string ReadUtf8Element(bsoncxx::document::view docvw, std::string key)</div><div class="ttdef"><b>Definition:</b> ProcessLocation.h:1</div></div>
<div class="ttc" id="arecursive_hierarch_search_8hpp_html_a6c3aafef43e91acd0d2542ea2c5337ac"><div class="ttname"><a href="recursive_hierarch_search_8hpp.html#a6c3aafef43e91acd0d2542ea2c5337ac">getNthColumn</a></div><div class="ttdeci">std::vector&lt; std::string &gt; getNthColumn(std::vector&lt; std::vector&lt; std::string &gt;&gt; matrix, unsigned colNo)</div><div class="ttdef"><b>Definition:</b> recursiveHierarchSearch.hpp:24</div></div>
<div class="ttc" id="a_type_proc_8h_html_a6475dfc685f8a583f49bd17b563a37fa"><div class="ttname"><a href="_type_proc_8h.html#a6475dfc685f8a583f49bd17b563a37fa">analyzeTypes</a></div><div class="ttdeci">void analyzeTypes(bsoncxx::builder::basic::document &amp;TypeNode, QualType Type, BinaryOpProperties &amp;BinOpProp, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> TypeProc.h:177</div></div>
<div class="ttc" id="astruct_total_location_info_html"><div class="ttname"><a href="struct_total_location_info.html">TotalLocationInfo</a></div><div class="ttdef"><b>Definition:</b> TypesForAnalysis.h:341</div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="_decl_proc_8h.html">DeclProc.h</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.17 </li>
  </ul>
</div>
</body>
</html>
